aboutsummaryrefslogtreecommitdiffstats
path: root/.ci/find-trailing-whitespaces.sh
diff options
context:
space:
mode:
Diffstat (limited to '.ci/find-trailing-whitespaces.sh')
-rwxr-xr-x.ci/find-trailing-whitespaces.sh39
1 files changed, 39 insertions, 0 deletions
diff --git a/.ci/find-trailing-whitespaces.sh b/.ci/find-trailing-whitespaces.sh
new file mode 100755
index 0000000000..d01984b54b
--- /dev/null
+++ b/.ci/find-trailing-whitespaces.sh
@@ -0,0 +1,39 @@
+#!/bin/sh
+
+# Copyright © 2021 Orange
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+set -e
+
+tw_lines="" # Lines containing trailing whitespaces.
+
+for file in $(git grep --cached -Il '' | sed -e 's/^/.\//')
+do
+ lines=$(grep -ErnIH " +$" $file | cut -f-2 -d ":")
+ if [ -n "$lines" ]; then
+ tw_lines=$([ -z "$tw_lines" ] && echo "$lines" || printf "%s\n%s" "$tw_lines" "$lines")
+ fi
+done
+
+exit_code=0
+
+
+# If tw_lines is not empty, change the exit code to 1 to fail the CI.
+if [ -n "$tw_lines" ]; then
+ printf "\n***** Lines containing trailing whitespace *****\n\n"
+ echo "${tw_lines}"
+ exit_code=1
+fi
+
+exit $exit_code